The OpenNET Project / Index page

[ новости /+++ | форум | wiki | теги | ]

Сохранение версий небольших проектов
Допустим Вы пишете скрипт или маленький проект из нескольких файлов.
Соответственно возникает желание периодически
сохранять результат своих трудов, чтобы в случае необходимости откатиться на шаг или два назад. 
Для крупного проекта идеально подойдет система контроля версий, а для маленькой
задачи подойдет и небольшой shell-скрипт.

Для начала использования скрипта достаточно:
- переименовать save.sh в просто save - для удобства набора в терминале
- разместить его где-нибудь в пределах охвата переменной окружения $PATH (тоже для удобства)
- определить в начале скрипта переменной SAVEDIR путь к желаемой директории хранения файлов

Вот этот shell-скрипт:

   #!/bin/sh

   SAVEDIR="${HOME}/save"   # where save backups
   LIMIT_BYTES=1048576      # set 1Mb limit

   SCRIPT="save"
   VERSION="20090903"

   if test "${1}"
   then
      echo "${SCRIPT} version ${VERSION}" >&2
      echo "Saves backup of whole current directory" >&2
      exit 1
   fi

   err()
   {
      echo "${SCRIPT}: ERROR: ${1}" >&2
      exit 1
   }

   #### check save directory
   test -d "${SAVEDIR}" || mkdir "${SAVEDIR}" 2>/dev/null
   test -d "${SAVEDIR}" || err "failed to create directory: ${SAVEDIR}"

   #### check size
   DIR="$(basename $(pwd))"
   DIR_SIZE_BYTES=$(du -s . | awk '{print $1}')
   test ${DIR_SIZE_BYTES} -gt ${LIMIT_BYTES} && err "size (${DIR_SIZE_BYTES}) of ${DIR} is greater than limit of ${LIMIT_BYTES}"

   #### saving
   cd .. || err "FAILED"
   tar cpzf "${SAVEDIR}/${DIR}.$(date +%Y%m%d%H%M%S).tar.gz" "${DIR}" || err "failed to create archive"
   echo "saved: ${DIR}"

Например, Вы пишете какой-то хороший ценный скрипт, соответственно предполагаем
что у Вас открыт терминал
и рабочей директорией является каталог с разрабатываемым скриптом или документов:

   $ pwd

   /home/user/tmp/mysmallproject

   $ ls -l
   
   итого 12
   -rwxr-xr-x 1 user users 895 2009-09-08 00:52 project.c
   -rwxr-xr-x 1 user users 170 2009-09-08 00:52 project.h
   -rwxr-xr-x 1 user users 865 2009-09-08 00:48 project.sh

Тогда для создания бэкапа просто наберите "save":

   $ save
   saved: mysmallproject

Все, копия файлов сохранена. Посмотрим на нее:

   $ ll /home/user/save/my*
   -rw-r--r-- 1 user users 1,1K 2009-09-08 00:54 /home/user/save/mysmallproject.20090908005453.tar.gz

Видим что скрипт в указанной директории создает архив текущего рабочего каталога и в имени архива 
дата до секунд. Это удобно, архивы аккуратно выстраиваются по дате.

В скрипте еще предусмотрена переменная LIMIT_BYTES, значение которой
ограничивает максимальный размер
текущей директории (рекурсивно, до архивирования). Это для того чтобы случайно
не архивировать что-то крупное.
 
Ключи: backup, shell, script / Лицензия: CC-BY
Раздел:    Корень / Программисту и web-разработчику / Shell / Готовые скрипты

Обсуждение [ Линейный режим | Показать все | RSS ]
 
  • 1.1, Админ Веня (?), 09:52, 09/09/2009 [ответить] [показать ветку] [···]    [к модератору]
  • +/
    rcs не пробовали смотреть?
     
  • 1.2, _Kuzmich (??), 10:44, 09/09/2009 [ответить] [показать ветку] [···]    [к модератору]
  • +/
    Забавный скрипт, оч. удобно имх.
     
  • 1.3, const86 (ok), 11:16, 09/09/2009 [ответить] [показать ветку] [···]    [к модератору]
  • +/
    Да VCS и для небольших проектов подходит. Даже если в проекте один файл.
     
     
  • 2.4, Slavaz (ok), 11:58, 09/09/2009 [^] [ответить]    [к модератору]
  • +/
    >Да VCS и для небольших проектов подходит. Даже если в проекте один
    >файл.

    +1. Не вижу смысла ломать устоявшиеся привычки ради одного-двух файлов.
    Даже если привычки нету. то освоить три-четыре команды какой-либо сушествующей VCS куда как полезнее привыкания к командам собственного производства.

     
  • 1.5, x0r (??), 12:09, 09/09/2009 [ответить] [показать ветку] [···]    [к модератору]
  • +/
    я тоже так сначала фигней страдал.
    поставь к примеру SVN и %:(?* не занимайся
     
     
  • 2.9, MaMoHT (?), 13:27, 09/09/2009 [^] [ответить]    [к модератору]  
  • +/
    Вот еще гемор - c SVN маятся: сервер запускать, репозиторий у него создавать.

    Че вы все страдаете этих анахроизмом - изучите уже git, mercurial, bazaar и будет вам счастье.

     
     
  • 3.11, Аноним (-), 14:40, 09/09/2009 [^] [ответить]    [к модератору]  
  • +/
    Сам толком этим пользоваться не умею, но по документации сделал локальный репозиторий с префиксом file:// и делаю коммиты. Тоже очень удобно.
     
  • 3.22, vayerx (?), 17:02, 15/09/2009 [^] [ответить]    [к модератору]  
  • +/
    >Вот еще гемор - c SVN маятся: сервер запускать, репозиторий у него
    >создавать.

    учите матчасть. серевер запускать вовсе не обязательно.
    про "создание репозитария" вообще смешно читать. сами-то хоть раз пробовали?

     
     
  • 4.25, Slavic (?), 06:59, 08/12/2011 [^] [ответить]    [к модератору]  
  • +/
    согласен
     
  • 1.6, Бу (?), 12:14, 09/09/2009 [ответить] [показать ветку] [···]    [к модератору]  
  • +/
    git наше фсио. даже не придется разделять working copy и репозиторий как таковой.
     
     
  • 2.7, mma (?), 12:19, 09/09/2009 [^] [ответить]    [к модератору]  
  • –1 +/
    гы-гы, так и представляю гит на проекте из трех файлов по 3кбайт:)
     
     
  • 3.10, MaMoHT (?), 13:40, 09/09/2009 [^] [ответить]    [к модератору]  
  • –1 +/
    >гы-гы, так и представляю гит на проекте из трех файлов по 3кбайт:)
    >

    Вот как раз git для этих целей ну просто замечательно подойдет, в отличии от SVN. И вообще он замечательно подходит в большинстве случаев, с SVN мароки знааааааачительно больше.

     
     
  • 4.23, vayerx (?), 17:06, 15/09/2009 [^] [ответить]    [к модератору]  
  • +/
    >>гы-гы, так и представляю гит на проекте из трех файлов по 3кбайт:)
    >
    >Вот как раз git для этих целей ну просто замечательно подойдет, в
    >отличии от SVN. И вообще он замечательно подходит в большинстве случаев,
    >с SVN мароки знааааааачительно больше.

    это пока у вас 3 файла по 3кб. давно в git'е работали с часто меняющимися бинарными файлами?

     
     
  • 5.24, Andrey Mitrofanov (?), 17:13, 15/09/2009 [^] [ответить]    [к модератору]  
  • +/
    >давно в git'е работали с часто меняющимися бинарными файлами?

    Уверен, со sparse-файлами, char и блочными устройствами и сохранением своп-файлов у SVN всё _ЗНАЧИИИТЕЛЬНО_ лучше. Или вы от другой Партии?

     
  • 3.12, User294 (ok), 15:23, 09/09/2009 [^] [ответить]    [к модератору]  
  • +/
    > гы-гы, так и представляю гит на проекте из трех файлов по 3кбайт:)

    Он будет довольно вменяемо смотреться даже для этой задачи, особенно если он уже установлен.

     
  • 1.8, keir (ok), 13:24, 09/09/2009 [ответить] [показать ветку] [···]    [к модератору]  
  • +/
    Полезно, спасибо.
     
  • 1.13, Ky6uk (?), 16:58, 09/09/2009 [ответить] [показать ветку] [···]    [к модератору]  
  • +1 +/
    По прочтении заголовка ожидал в совете пару git-команд, но никак не скрипт "save".
     
  • 1.14, Vasily Pupkin (?), 20:30, 09/09/2009 [ответить] [показать ветку] [···]    [к модератору]  
  • +1 +/
    ~$ apt-get install bzr # see also: bzrtools bzr-gtk qbzr
    ~$ mkdir proj; cd proj
    ~/proj$ bzr init
    Created a standalone tree (format: pack-0.92)
    ~/proj$ echo foo > foo
    ~/proj$ bzr add
    adding foo
    ~/proj$ bzr commit -m 'adding foo'
    Committing to: /home/user/proj/
    added foo
    Committed revision 1.
    ~/proj$ echo bazaar rulez >> foo
    ~/proj$ bzr diff
    === modified file 'foo'
    --- foo 2009-09-09 16:11:38 +0000
    +++ foo 2009-09-09 16:12:23 +0000
    @@ -1,1 +1,2 @@
    foo
    +bazaar rulez

    ~/proj$ bzr commit -m 'bzr rulez'
    Committing to: /home/user/proj/
    modified foo
    Committed revision 2.
    ~/proj$ bzr diff
    ~/proj$ bzr log
    ------------------------------------------------------------
    revno: 2
    committer: Vasily Pupkin <pupkin@gmail.com>
    branch nick: proj
    timestamp: Wed 2009-09-09 19:12:52 +0300
    message:
      bzr rulez
    ------------------------------------------------------------
    revno: 1
    committer: Vasily Pupkin <pupkin@gmail.com>
    branch nick: proj
    timestamp: Wed 2009-09-09 19:11:38 +0300
    message:
      adding foo
    ~/proj$ cat foo
    foo
    bazaar rulez
    ~/proj$ bzr cat -r1 foo
    foo
    ~/proj$ bzr help | less
    ~/proj$ bzr visualize #this needs bzr-gtk
    ~/proj$ firefox http://doc.bazaar-vcs.org/latest/en/mini-tutorial/index.html

     
     
  • 2.15, Марецкий Александр (?), 22:16, 09/09/2009 [^] [ответить]    [к модератору]  
  • +/
    Впечатляет. Однако мой вариант все равно намного проще, очень простой и удобный для просто написания скриптов, инсталляция - один маленький файлик, unix-way, и для подлинно мелких но многочисленных задач отлично подходит. Пользоваться bazaar для написания кучи мелких скриптов на разных машинах наверное не буду, а вот если что-то покрупнее - тогда другое дело
     
  • 1.16, Aleksey (??), 14:35, 10/09/2009 [ответить] [показать ветку] [···]    [к модератору]  
  • +/
    http://www.samag.ru/cgi-bin/go.pl?q=articles;n=03.2007;a=03
     
  • 1.18, Michael Shigorin (ok), 20:57, 13/09/2009 [ответить] [показать ветку] [···]    [к модератору]  
  • +1 +/
    Нет, всё-таки ради одного git diff уже стоит освоить даже для полутора файлов:
    git init
    git commit -am 'commit message'

    А потом ещё до кучи посмотреть git status, git log -p и сделать для себя выводы.

    http://www.kernel.org/pub/software/scm/git/docs/everyday.html
    http://freesource.info/wiki/RuslanHihin/20povsedevnyxkomandgit

    И опять же потом до кучи:
    http://tomayko.com/writings/the-thing-about-git

     
  • 1.19, Pilat (ok), 20:58, 13/09/2009 [ответить] [показать ветку] [···]    [к модератору]  
  • +/
    Варианты сходу приходящие в голову:
    - rdiff-rsync
    - dar

    все они способны хранить версии. dar - отличия в одном на каждую версию, rdiff - в разветвлённой файловой структуре. Но с системами контроля версий им не сравниться - не та ниша.

    Кстати, сам tar вполне способен хранить инкрементальные копии, значит из него можно извлечь состояние на заданную дату.

     
     
  • 2.20, zer0 (?), 15:23, 14/09/2009 [^] [ответить]    [к модератору]  
  • +/
    А мне squashfs вспомнился, он тоже версии поддерживает и делает диффы между версиями =)
     
     
  • 3.21, Andrey Mitrofanov (?), 17:32, 14/09/2009 [^] [ответить]    [к модератору]  
  • +/
    "SQUASHFS - A squashed read-only filesystem"? Ничего не путаете?
     

    Ваш комментарий
    Имя:         
    E-Mail:      
    Заголовок:
    Текст:



      Закладки на сайте
      Проследить за страницей
    Created 1996-2019 by Maxim Chirkov  
    ДобавитьПоддержатьВебмастеруГИД  
    Hosting by Ihor